# define LINELEN_MAX 160
typedef struct {
	char name[5];
	char aa[20];
	char ambername[5];
	char bcctype[5];
	char element[5];
	char resid[10];
        char chain[2];
	double x;
	double y;
	double z;
	double radius;
	double charge;
	double eps;
	double lja;
	double ljb;
	double bond;
	double angle;
	double twist;
        int ter;
	int resno;
	int hdonor;
	int haccept;
	int atomtype;
	int con[6];
	int bondatom;
	int angleatom;
	int twistatom;
	int connum;
	int mainatom;
	int atomicnum;
	int select;
	int ewd;		/* electrwithdraw or not: 1 ewd; -1 edonor; 0 others */
	int arom;		/* 5: 5 mem.ring aromatic atom; 6: 6 mem.ring aromatic atom;
       
								   -1: aliphatic; 0: others */
	int aliph;
	int saturate;				/* 1: saturated; -1 unsaturated; */
	int improper;
} ATOM;
typedef struct {
	char name[5];
	double x;
	double y;
	double z;
} ATOMSML;
typedef struct {
	char name[5];
	int atomtype;
	int con[4];
	double x;
	double y;
	double z;
	double charge;
} ATOMDBS;
typedef struct {
	char name[5];
	double x;
	double y;
	double z;
	double radius;
	double charge;
	double eps;
	double lja;
	double ljb;
	int hdonor;
	int haccept;
	int atomtype;
	int con[4];
} LIGATOM;
typedef struct {
	int atm1;
	int atm2;
	int atm3;
	int atm4;
	char type;
	double k;
	double kexi;
	int multi;
} TWIST;
typedef struct {
	double x;
	double y;
	double z;
} POINT;
typedef struct {
	int atomno;
	double x;
	double y;
	double z;
	double esp;
	double dist;
} ESP;
typedef struct {
	double x;
	double y;
	double z;
	double total;
} DM;
typedef struct {
	double xx;
	double yy;
	double zz;
	double xy;
	double xz;
	double yz;
} QM;
typedef struct {
	int atconnum;
        int apindex;
        char ap[512];
	char atname[5];
	char cesname[5];
} CHEMENV;

typedef struct {
        int bondi;
        int bondj;
        int type;
	double bcc;
} BOND;

typedef struct {
	char name1[5];
	char name2[5];
	double length;
	double force;
} BOND_FF;

typedef struct {
        int num;
        int atomno[12];
} RING;

typedef struct {
        int nr;
        int ar1;
        int ar2;
        int ar3;
        int ar4;
        int ar5;
        int rg[12];
} AROM;

typedef struct {
        char gkeyword[MAXCHAR] ;
        char mkeyword[MAXCHAR];
        char resname[20];
	char chkfile[20];
        char atom_type_def[6];
        char mopac_prog[MAXCHAR]; 
        char resfilename[MAXCHAR];
        char gfilename[MAXCHAR];
        char connect_file[MAXCHAR];
        char radius_file[MAXCHAR];
        char longresname[MAXCHAR];
        char inf_filename[MAXCHAR];
        int multiplicity; /*molecular multiplicity*/
        int icharge ; /*integer charge */
        int usercharge; /*user read in charge*/
        double dcharge; /*float charge*/
} MOLINFO;

typedef struct {
        char intype[10];       
        char outtype[10];       
        char atype[10];
        char chargetype[10];
        int rnindex; /*read in residue index ?*/ 
        int intstatus; /*information statius*/  
        int pfindex; /*purify intermediate files*/
        int prediction_index; /*the index of performing atomtype */
        int bpindex; /*bond type prediciton index*/
        int  maxatom; 
        int  maxbond;
        int  maxring;
} CONTROLINFO;

typedef struct {
        char name[5];
        double a;
        double b;
        double c;
} GASTEIGER;

typedef struct {
        char name[6];
} NAME;

typedef struct {
        int aps[8];
} AV;
