
#include "common.h"
#include "define.h"
#include "atom.h"
#include "globals.h"

void newitoa(long num, char *str)
{
	int i = 0;
	int j;
	long tmpint, mod;
	char tmpchar[20];
	strcpy(str, "");
	while (num >= 10) {
		tmpint = num / 10;
		mod = num - tmpint * 10;
		switch (mod) {
		case 0:
			tmpchar[i] = '0';
			break;
		case 1:
			tmpchar[i] = '1';
			break;
		case 2:
			tmpchar[i] = '2';
			break;
		case 3:
			tmpchar[i] = '3';
			break;
		case 4:
			tmpchar[i] = '4';
			break;
		case 5:
			tmpchar[i] = '5';
			break;
		case 6:
			tmpchar[i] = '6';
			break;
		case 7:
			tmpchar[i] = '7';
			break;
		case 8:
			tmpchar[i] = '8';
			break;
		case 9:
			tmpchar[i] = '9';
			break;
		}
		i++;
		num = tmpint;
	}
	switch (num) {
	case 0:
		tmpchar[i] = '0';
		break;
	case 1:
		tmpchar[i] = '1';
		break;
	case 2:
		tmpchar[i] = '2';
		break;
	case 3:
		tmpchar[i] = '3';
		break;
	case 4:
		tmpchar[i] = '4';
		break;
	case 5:
		tmpchar[i] = '5';
		break;
	case 6:
		tmpchar[i] = '6';
		break;
	case 7:
		tmpchar[i] = '7';
		break;
	case 8:
		tmpchar[i] = '8';
		break;
	case 9:
		tmpchar[i] = '9';
		break;
	}
	i++;
	for (j = 0; j < i; j++)
		str[j] = tmpchar[i - j - 1];
	str[i] = '\0';
	/*   printf("\n %5d",i);
	   printf("\n %s", tmpchar);
	   printf("\n %s", str); */
}

double distance(ATOMBIG at1, ATOMBIG at2)
{
	double dist;
	dist = (at1.x - at2.x) * (at1.x - at2.x);
	dist += (at1.y - at2.y) * (at1.y - at2.y);
	dist += (at1.z - at2.z) * (at1.z - at2.z);
	dist = sqrt(dist);
	return dist;
}

void default_inf(void)
{
	int i;
	for (i = 0; i < MAXATOM; i++) {
		if (strcmp("mpdb", intype) != 0 && strcmp("4", intype) != 0)
			strcpy(atom[i].ambername, atom[i].name);
		strcpy(atom[i].bcctype, atom[i].name);
	}
}

void totalcharge(void)
{
	int i;
	double tmpf;
	double tmpcharge = 0.0;

	if (usercharge > -999) {
		intcharge = usercharge;
		charge = usercharge;
	} else {
		charge = 0.0;

		for (i = 0; i < atomnum; i++)
			charge += atom[i].charge;
		tmpcharge = modf(charge, &tmpf);
		intcharge = tmpf;
		if (fabs(tmpcharge) >= 0.50) {
			if (charge < 0)
				intcharge--;
			if (charge > 0)
				intcharge++;
		}
	}
}

void adjustatomname(void)
{								/* just strips blanks out of the atomname */
	int i, j;
	int num;
	char tmpchar[5];
	for (i = 0; i < atomnum; i++) {
		num = 0;
		tmpchar[0] = '\0';
		for (j = 0; j < strlen(atom[i].name); j++) {
			if (atom[i].name[j] == ' ')
				continue;
			tmpchar[num] = atom[i].name[j];
			if (tmpchar[num] == '\0')
				break;
			num++;
		}
		tmpchar[num] = '\0';
		strcpy(atom[i].name, tmpchar);
	}
}

void formula(void)
{
	int i, j;
	int countatom[150];
	char tmpchar[10];
	char elemname[150][5];
	for (i = 0; i < 150; i++) {
		countatom[i] = 0;
		strcpy(elemname[i], "X");
	}
	strcpy(elemname[1], "H");
	strcpy(elemname[6], "C");
	strcpy(elemname[7], "N");
	strcpy(elemname[8], "O");
	strcpy(elemname[9], "F");
	strcpy(elemname[17], "Cl");
	strcpy(elemname[35], "Br");
	strcpy(elemname[53], "I");
	strcpy(elemname[16], "S");
	strcpy(elemname[15], "P");
	strcpy(elemname[14], "Si");
	strcpy(elemname[11], "Na");
	strcpy(elemname[12], "Mg");
	strcpy(elemname[25], "Mn");
	strcpy(elemname[26], "Fe");
	strcpy(elemname[27], "Co");
	strcpy(elemname[28], "Ni");
	strcpy(elemname[29], "Cu");
	strcpy(elemname[30], "Zn");
	strcpy(elemname[5], "B");

	for (j = 0; j < atomnum; j++)
		countatom[atom[j].atomicnum]++;
	form[0] = '\0';
	for (i = 0; i < 150; i++)
		if (countatom[i] >= 1) {
			strcat(form, elemname[i]);
			newitoa(countatom[i], tmpchar);
			strcat(form, tmpchar);
		}
}

void mark_improper(void)
{
	int i, j;
	int index;
	int tmpint;
	for (i = 0; i < atomnum; i++) {

		if (atom[i].atomicnum == 6 && atom[i].connum == 3)
			atom[i].improper = 1;

		if (atom[i].atomicnum == 7 && atom[i].connum == 3
			&& atom[i].arom >= 5)
			atom[i].improper = 1;

		if (atom[i].ambername[0] == 'c' && atom[i].ambername[1] == ' ') {
			/* sp2 carbonyl carbon */
			index = 0;
			for (j = 0; j < 3; j++) {
				tmpint = atom[i].con[j];
				if (tmpint == -1)
					break;
				if (atom[tmpint].atomicnum == 7) {
					index = 1;
					break;
				}
			}
			if (index == 1)
				atom[i].improper = 1;
		}

		if (atom[i].atomicnum == 7 && atom[i].arom == 0) {
			/* check for NH2 group attached to aromatic ring:  */
			index = 0;
			for (j = 0; j < 3; j++) {
				tmpint = atom[i].con[j];
				if (tmpint == -1)
					break;
				if (atom[tmpint].arom >= 5) {
					index = 1;
					break;
				}
			}
			if (index == 1)
				atom[i].improper = 1;
		}
#if 0
		fprintf(stderr, "%5d%5d%5d%5d%5d %s\n",
				i, atom[i].atomicnum, atom[i].connum, atom[i].arom,
				atom[i].improper, atom[i].ambername);
#endif

	}
}

void connect(void)
{
	int i, j;
	int tmpint;
	double tmpfloat;
	FILE *fpin;
	if ((fpin = fopen(connect_file, "r")) == NULL) {
		fprintf(stderr, "Cannot open %s , exit\n", connect_file);
		exit(1);
	}
	for (;;) {
		if (fgets(line, LINELEN_MAX, fpin) == NULL)
			break;
		if (strncmp(".", &line[10], 1) == 0)
			sscanf(&line[3], "%d%lf", &tmpint, &tmpfloat);
		connectradius[tmpint] = tmpfloat;
	}
	for (i = 0; i < atomnum; i++) {
		atom[i].connum = 0;
		atom[i].con[0] = -1;
		atom[i].con[1] = -1;
		atom[i].con[2] = -1;
		atom[i].con[3] = -1;
		atom[i].con[4] = -1;
		atom[i].con[5] = -1;
	}
	for (i = 0; i < atomnum - 1; i++)
		for (j = i + 1; j < atomnum; j++) {
			tmpfloat = distance(atom[i], atom[j]);
			if (tmpfloat < connectradius[atom[i].atomicnum] +
				connectradius[atom[j].atomicnum] + 0.2)
				if (tmpfloat > (connectradius[atom[i].atomicnum] +
								connectradius[atom[j].atomicnum]) * 0.5)
					if (atom[i].connum < 6 && atom[j].connum < 6) {
						atom[i].con[atom[i].connum++] = j;
						atom[j].con[atom[j].connum++] = i;
					}
		}
	fclose(fpin);
}

void initial(void)
{
	int i;
	for (i = 0; i < MAXATOM; i++) {
		atom[i].connum = 0;
		atom[i].resno = 1;
		atom[i].con[0] = -1;
		atom[i].con[1] = -1;
		atom[i].con[2] = -1;
		atom[i].con[3] = -1;
		atom[i].con[4] = -1;
		atom[i].con[5] = -1;
		atom[i].improper = 0;
		strcpy(atom[i].aa, resname);
	}
}

void atomicnum(void)
{
	int i;
	for (i = 0; i < atomnum; i++) {
		switch (atom[i].name[0]) {
		case 'H':
			atom[i].atomicnum = 1;
			break;
		case 'C':
			if (atom[i].name[1] != 'l' && atom[i].name[1] != 'L')
				atom[i].atomicnum = 6;
			else
				atom[i].atomicnum = 17;
			break;
		case 'M':
			if (atom[i].name[1] == 'n')
				atom[i].atomicnum = 25;
			else if (atom[i].name[1] == 'g')
				atom[i].atomicnum = 12;
			break;
		case 'N':
			atom[i].atomicnum = 7;
			break;
		case 'O':
			atom[i].atomicnum = 8;
			break;
		case 'F':
			if (atom[i].name[1] == 'e')
				atom[i].atomicnum = 26;
			else
				atom[i].atomicnum = 9;
			break;
		case 'B':
			if (atom[i].name[1] == 'r' || atom[i].name[1] == 'R')
				atom[i].atomicnum = 35;
			else
				atom[i].atomicnum = 5;
			break;
		case 'S':
			atom[i].atomicnum = 16;
			break;
		case 'P':
			atom[i].atomicnum = 15;
			break;
		case 'I':
			atom[i].atomicnum = 53;
			break;
		case 'l':
			if (atom[i].name[1] == 'p')
				atom[i].atomicnum = 0;
			break;
		case 'L':
			if (atom[i].name[1] == 'P')
				atom[i].atomicnum = 0;
			break;
		default:
			printf("\n Unrecognized atomic name %5s, exit", atom[i].name);
		}
	}
}
